## darktable 0.9

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#
# Install Doc files
#
set(DOC_FILES README AUTHORS TRANSLATORS LICENSE)
install(FILES ${DOC_FILES} DESTINATION ./share/doc/darktable)

# Build manual page
add_custom_command(
	OUTPUT darktable.1
	SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/darktable.pod
	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/makeman.sh ${CMAKE_CURRENT_SOURCE_DIR}/darktable.pod ${CMAKE_CURRENT_BINARY_DIR}/../src/config.h ${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS ${CMAKE_CURRENT_BINARY_DIR}/darktable.1
	${CMAKE_CURRENT_SOURCE_DIR}/darktable.pod 
	${CMAKE_CURRENT_BINARY_DIR}/darktable.1 
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/darktable.pod
	
)

add_custom_target(manpages ALL DEPENDS darktable.1)


install(FILES ${CMAKE_CURRENT_BINARY_DIR}/darktable.1 DESTINATION ./share/man/man1)

add_subdirectory(usermanual)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#
# Add files for libdarktable
#
FILE(GLOB SOURCE_FILES
  "common/collection.c" 
  "common/colorlabels.c" 
  "common/colormatrices.c" 
  "common/colorspaces.c" 
  "common/darktable.c" 
  "common/exif.cc" 
  "common/film.c" 
  "common/fswatch.c" 
  "common/history.c" 
  "common/image.c" 
  "common/image_cache.c" 
  "common/image_compression.c" 
  "common/imageio.c" 
  "common/imageio_exr.cc" 
  "common/imageio_jpeg.c" 
  "common/imageio_module.c" 
  "common/imageio_pfm.c" 
  "common/imageio_rgbe.c" 
  "common/imageio_tiff.c" 
  "common/imageio_rawspeed.cc" 
  "common/metadata.c" 
  "common/styles.c" 
  "common/tags.c" 
  "common/utility.c" 
  "common/variables.c" 
  "common/pwstorage/pwstorage.c" 
  "common/pwstorage/backend_gconf.c"
  "common/opencl.c"
  "common/dynload.c"
  "common/dlopencl.c"
  "control/control.c"  
  "control/jobs/control_jobs.c"  
  "control/jobs/develop_jobs.c"  
  "control/jobs/film_jobs.c"  
  "control/jobs/image_jobs.c"  
  "develop/develop.c"
  "develop/imageop.c"
  "develop/pixelpipe.c"
  "develop/blend.c"
  "dtgtk/*.c" 
  "gui/background_jobs.c"  
  "gui/contrast.c"  
  "gui/gtk.c"  
  "gui/histogram.c"  
  "gui/iop_history.c"  
  "gui/iop_modulegroups.c"  
  "gui/metadata.c"  
  "gui/navigation.c"  
  "gui/preferences.c"  
  "gui/presets.c"  
  "gui/styles_dialog.c"  
  "gui/tool_colorlabels.c"  
  "libs/lib.c"
  "views/view.c"
  )
FILE(GLOB HEADER_FILES "*.h" "common/*.h" "external/CL/*.h" "control/*.h" "iop/*.h" "libs/*.h", "views/*.h")

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES})


include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/LibRaw)

# initial compiler flags
add_definitions("-DHAVE_CONFIG_H")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")

# Check for openmp
find_package(OpenMP)
if(OPENMP_FOUND AND USE_OPENMP)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  add_definitions("-DHAVE_OPENMP")
endif(OPENMP_FOUND AND USE_OPENMP)

if(USE_DARKTABLE_PROFILING)
	add_definitions(-DUSE_DARKTABLE_PROFILING)
	set(SOURCES ${SOURCES} "common/profiling.c")
endif()

#
# Find all other required libraries for building
#
find_package(GTK2 2.6 REQUIRED gtk)
include_directories(${GTK2_INCLUDE_DIRS})
list(APPEND LIBS ${GTK2_LIBRARIES})
add_definitions(${GTK2_DEFINITIONS})

# Check for libxml2 / broken cmake module can't be included in the foreach() below
find_package(LibXml2 2.6 REQUIRED)
include_directories(${LIBXML2_INCLUDE_DIR})
list(APPEND LIBS ${LIBXML2_LIBRARIES})
add_definitions(${LIBXML2_DEFINITIONS})


# Check for gconf2 / broken cmake module can't be included in the foreach() below
if(USE_GCONF_BACKEND)
  find_package(GConf2)
  include_directories(${GConf2_INCLUDE_DIRS})
  list(APPEND LIBS ${GConf2_LIBRARIES})
  add_definitions(${GConf2_DEFINITIONS})
endif(USE_GCONF_BACKEND)



if(USE_CAMERA_SUPPORT)
  find_package(Gphoto2)
  include_directories(${Gphoto2_INCLUDE_DIRS})
  list(APPEND LIBS ${Gphoto2_LIBRARIES})
  add_definitions(${Gphoto2_DEFINITIONS})
endif(USE_CAMERA_SUPPORT)

# Find all the libs that don't require extra parameters
foreach(lib ${OUR_LIBS} LensFun GIO GThread GModule Cairo PangoCairo PThread Rsvg2 GDK-PixBuf LibXml2 INotify Sqlite3 Exiv2  CURL PNG JPEG TIFF OpenEXR LCMS2)
  find_package(${lib} REQUIRED)
  include_directories(${${lib}_INCLUDE_DIRS})
  list(APPEND LIBS ${${lib}_LIBRARIES})
  add_definitions(${${lib}_DEFINITIONS})
endforeach(lib)

find_package(Gettext)
if(Gettext_FOUND)
  include_directories(${Gettext_INCLUDE_DIRS})
  list(APPEND LIBS ${Gettext_LIBRARIES})
  add_definitions("-DUSE_GETTEXT")
  message(STATUS "Internationalization: Enabled")
else()
  message(STATUS "Internationalization: Disabled (libintl not found)")
endif()

find_package(FLICKCURL)
if(FLICKCURL_FOUND)
  include_directories(${FLICKCURL_INCLUDE_DIRS})
  list(APPEND LIBS ${FLICKCURL_LIBRARIES})
  add_definitions(${FLICKCURL_DEFINITIONS})
endif(FLICKCURL_FOUND)

#
# Detect compile of optional pwstorage backends
#
find_package(DBUSGLIB)
if(DBUSGLIB_FOUND)
  list(APPEND SOURCES "common/pwstorage/backend_kwallet.c")
  include_directories(${DBUSGLIB_INCLUDE_DIRS})
  list(APPEND LIBS ${DBUSGLIB_LIBRARIES})
  add_definitions("-DHAVE_KWALLET")
endif(DBUSGLIB_FOUND)

find_package(GnomeKeyring)
if(GNOMEKEYRING_FOUND)
  set(SOURCES ${SOURCES} "common/pwstorage/backend_gkeyring.c")
  include_directories(${GnomeKeyring_INCLUDE_DIRS})
  list(APPEND LIBS ${GnomeKeyring_LIBRARIES})
  add_definitions("-DHAVE_GKEYRING")
endif(GNOMEKEYRING_FOUND)

# have a small test program, to be run as root on some systems to enable the driver to run cl stuff
add_subdirectory(cltest)

# build opengl slideshow viewer?
find_package(SDL)
find_package(OpenGL)
if(SDL_FOUND AND OPENGL_FOUND)
  add_subdirectory(dtview)
endif(SDL_FOUND AND OPENGL_FOUND)

# needed for the file manager
if(APRIL_FOOLS)
  find_package(VTE)
  if(VTE_FOUND)
    include_directories(${VTE_INCLUDE_DIRS})
    list(APPEND LIBS ${VTE_LIBRARIES})
  endif(VTE_FOUND)
endif(APRIL_FOOLS)

#
# Add HAVE_xxx defines used by darktable
#
if(INOTIFY_FOUND)
  add_definitions("-DHAVE_INOTIFY")
endif(INOTIFY_FOUND)

if(LENSFUN_FOUND)
  add_definitions("-DHAVE_LENSFUN")
endif(LENSFUN_FOUND)

if(GCONF2_FOUND)
  add_definitions("-DHAVE_GCONF")
endif(GCONF2_FOUND)

if(OPENEXR_FOUND)
  add_definitions("-DHAVE_OPENEXR")
endif(OPENEXR_FOUND)

if(USE_OPENCL)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external)
  add_definitions("-DHAVE_OPENCL")
endif(USE_OPENCL)


if(GPHOTO2_FOUND)
  set(SOURCES ${SOURCES} "common/camera_control.c" "control/jobs/camera_jobs.c" "gui/camera_import_dialog.c" "gui/devices.c" )
  add_definitions("-DHAVE_GPHOTO2")
endif(GPHOTO2_FOUND)


#
# Set default compile flags for GCC
#
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fno-strict-aliasing")
# c++ code doesn't like -Werror (libraw)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fno-strict-aliasing")

if(NOT APPLE)
  # apple build fails on deprecated warnings..
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
endif(NOT APPLE)

if(NOT WIN32)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
endif(NOT WIN32)

if(NOT BINARY_PACKAGE_BUILD)
	set(MARCH "-march=native")	
else()
	set(MARCH "-mtune=generic")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g -D_DEBUG")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -D_DEBUG")
  

#
# Generate config.h
#
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.h" "${CMAKE_CURRENT_BINARY_DIR}/config.h" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")


#
# Setup generation of preference dialog files..
#
add_custom_command(
   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h
   COMMAND ${CMAKE_CURRENT_BINARY_DIR}/../create_preferences.sh ${CMAKE_CURRENT_SOURCE_DIR}/../data/darktable.schemas > ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h
)
SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h PROPERTIES GENERATED 1)

#
# Generate mapping of key strings to internal metadata id
#
add_custom_command(
   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c
   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/create_metadata.sh ${CMAKE_CURRENT_SOURCE_DIR}/../tools/metadata.txt ${CMAKE_CURRENT_BINARY_DIR}
)
SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h PROPERTIES GENERATED 1)
# this is a dummy library whose sole purpose is to serve as a dependency for subdirs, such as imageio/storage/gallery.
# cmake can't depend on custom targets in other directories than the current one.
add_library(metadata_dummy ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h)

#
# build libdarktable
#
add_library(lib_darktable STATIC SHARED ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c ${SOURCES})
if(APPLE)
  set_target_properties(lib_darktable PROPERTIES INSTALL_NAME_DIR "@executable_path/../lib/darktable")
endif(APPLE)
set_target_properties(lib_darktable PROPERTIES OUTPUT_NAME darktable)
set_target_properties(lib_darktable PROPERTIES LINKER_LANGUAGE C)


#
# the libraw part is a bit of a hack:
# the static linking didn't work since it was pulling -lstdc++ and -lm into linker flags.
# so we do a custom dependency and pretend an imported liblibraw_r.a so no other -l are
# appended.
#
add_dependencies(lib_darktable libraw_r)
add_library(libraw_static STATIC IMPORTED)
set_target_properties(libraw_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/LibRaw/liblibraw_r.a)
target_link_libraries(lib_darktable ${LIBS} libraw_static)

# same for librawspeed (can switch it off with -DDONT_USE_RAWSPEED, for macs):
if(NOT DONT_USE_RAWSPEED)
  add_definitions("-DHAVE_RAWSPEED")
  add_dependencies(lib_darktable rawspeed)
  add_library(rawspeed_static STATIC IMPORTED)
  set_target_properties(rawspeed_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/rawspeed/librawspeed.a)
  target_link_libraries(lib_darktable ${LIBS} rawspeed_static)
  # compile rawspeed
  add_subdirectory(rawspeed)
endif(NOT DONT_USE_RAWSPEED)

install(TARGETS lib_darktable DESTINATION ${LIB_INSTALL}/darktable)
list(APPEND LIBS lib_darktable)

# Compile libraw modules
add_subdirectory(LibRaw)

# Compile views modules
add_subdirectory(views)

# Compile lighttable modules
add_subdirectory(libs)

# Compile darkroom modules
add_subdirectory(iop)

# Compile export modules
add_subdirectory(imageio)




#
# build darktable executable
#
add_executable(darktable ${SUBSYSTEM_MACOSX} ${SUBSYSTEM_WIN32} main.c ${RESOURCE_OBJECT})
set_target_properties(darktable PROPERTIES CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
set_target_properties(darktable PROPERTIES CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
set_target_properties(darktable PROPERTIES INSTALL_RPATH $ORIGIN/../${LIB_INSTALL}/darktable)
set_target_properties(darktable PROPERTIES LINKER_LANGUAGE C)
target_link_libraries(darktable ${LIBS})
install(TARGETS darktable DESTINATION bin)

=== data/pixmaps/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#
# Install fixed sized icons
#
set(FIXED_SIZES "16x16" "22x22" "32x32" "48x48" "64x64" "scalable")
foreach(pixmap_size ${FIXED_SIZES})
	# install apps icons
	FILE(GLOB PIXMAP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/${pixmap_size}/*.png ${CMAKE_CURRENT_SOURCE_DIR}/${pixmap_size}/*.svg)
	install(FILES ${PIXMAP_FILES} DESTINATION ./share/icons/${THEME}/${pixmap_size}/apps)
endforeach(pixmap_size)

#
# Install plugin pixmaps
#
FILE(GLOB DARKROOM_PLUGIN_PIXMAPS "plugins/darkroom/*.png")
install(FILES ${DARKROOM_PLUGIN_PIXMAPS} DESTINATION ${SHARE_INSTALL}/pixmaps/plugins/darkroom )


#
# Add debian package postinstall icon cache update
#
#set(GTK_UPDATE_ICON_CACHE "gtk-update-icon-cache -f -t ${THEME_DIRECTORY}")
#set(POSTINSTALL_SCRIPT "# update icon cache\n
#	if test -z \"$(DESTDIR)\"; then\n 
#		echo \"Updating Gtk icon cache.\"; \n 
#		${GTK_UPDATE_ICON_CACHE};\n
#	else \n 
#		echo \"*** Icon cache not updated. After (un)install, run this:\";\n 
#		echo \"*** ${GTK_UPDATE_ICON_CACHE}\";\n
#	fi")
#file(APPEND ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/debian/postinst "${POSTINSTALL_SCRIPT}")

=== src/LibRaw/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(LIBRAW_SOURCES internal/dcraw_common.cpp src/libraw_cxx.cpp internal/dcraw_fileio.cpp internal/demosaic_packs.cpp src/libraw_c_api.cpp)

#
# build liblibraw_r
#
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

add_library(libraw_r STATIC ${LIBRAW_SOURCES})
target_link_libraries(libraw_r)

=== src/imageio/storage/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories("${CMAKE_CURRENT_BINARY_DIR}/../../" "${CMAKE_CURRENT_SOURCE_DIR}")
set(MODULES disk picasa email gallery)

if(FLICKCURL_FOUND)
	list(APPEND MODULES flickr)
endif(FLICKCURL_FOUND)

foreach(module ${MODULES} ${MODULES_EXPERIMENTAL})
	add_library(${module} MODULE "${module}.c")
endforeach(module)
add_dependencies(gallery metadata_dummy)

foreach(module ${MODULES})
	target_link_libraries(${module} ${LIBS})
	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/plugins/imageio/storage)
endforeach(module)

 
if(INSTALL_IOP_EXPERIMENTAL)
foreach(module ${MODULES_EXPERIMENTAL})
	target_link_libraries(${module} ${LIBS})
	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/plugins/imageio/storage)
endforeach(module)
endif(INSTALL_IOP_EXPERIMENTAL)

=== debian/changelog ===
darktable (0.9-1) unstable; urgency=low

  * New upstream release.
  * Remove all patches now upstream; only patch for
    -Wno-error=unused-but-set-variable remains.
  * Bump Standards-Version to 3.9.2 (no changes)

 -- David Bremner <bremner@debian.org>  Tue, 12 Jul 2011 09:36:46 -0300

darktable (0.8-4) unstable; urgency=low

  * Really restrict architecture to any-i386, any-amd64
  * Add -Wno-error=unused-but-set-variable (Closes: #625315)

 -- David Bremner <bremner@debian.org>  Tue, 03 May 2011 22:19:33 -0300

darktable (0.8-3) unstable; urgency=low

  * Restrict architecture to any-i386, any-amd64
  * Backport upstream commits to more gracefully deal with missing sse2
    support (Closes: #623393).

 -- David Bremner <bremner@debian.org>  Thu, 21 Apr 2011 22:35:03 -0300

darktable (0.8-2) unstable; urgency=low

  * Enable cmake option BINARY_PACKAGE_BUILD, which disables build host
    specific optimizations.

 -- David Bremner <bremner@debian.org>  Thu, 14 Apr 2011 23:42:12 -0300

darktable (0.8-1) unstable; urgency=low

  [ Bernd Zeimetz ]
  * Initial release (Closes: #553359)

 -- David Bremner <bremner@debian.org>  Tue, 22 Feb 2011 07:58:31 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

SOURCEPKG=$(shell dpkg-parsechangelog | sed  -n 's/^Source: \(.*\)/\1/p')
UPSTREAM=$(shell dpkg-parsechangelog |  sed -n 's/^Version: \(.*\)-[^-]*/\1/p')
SHA1=$(lastword $(subst ~g, ,$(UPSTREAM)))
ORIG=${SOURCEPKG}_${UPSTREAM}.orig.tar.gz

# exclude any plugins from the main package that are in one of the "special" plugin packages
PLUGIN_EXCLUDES=$(patsubst %,-X%,$(notdir $(shell cat $(wildcard debian/darktable-plugins-*.install))))

export CONFIG_SHELL=/bin/bash

%:
	dh $@ --parallel

override_dh_auto_configure: cmake/version.cmake
	dh_auto_configure -- -DDONT_INSTALL_GCONF_SCHEMAS=1 -DINSTALL_IOP_LEGACY=1 -DINSTALL_IOP_EXPERIMENTAL=1 -DBINARY_PACKAGE_BUILD=1

override_dh_auto_build:
	dh_auto_build

override_dh_strip:
	dh_strip --dbg-package=darktable-dbg

override_dh_install:
	dh_install -pdarktable $(PLUGIN_EXCLUDES)
	dh_install --remaining-packages

describe-current-version:
	git describe --tags upstream | sed 's,^release-,,;s,-,+,;s,-,~,;'

get-orig-source:
	git archive --format=tar $(SHA1) | gzip -9 > ../$(ORIG)

.PHONY: describe-current-version git-orig-source

cmake/version.cmake:
	echo "set(PROJECT_VERSION \"${UPSTREAM}\")" > $@

PATCH_EXPORT_SCRIPT=/usr/share/gitpkg/hooks/quilt-patches-deb-export-hook
.PHONY: export-patches

export-patches: 
	[ ! -r debian/patches ] || \
	grep "^\#.*$(notdir $(PATCH_EXPORT_SCRIPT))" debian/patches/series
	rm -rf debian/patches
	sh $(PATCH_EXPORT_SCRIPT)

## darktable 0.9.1

=== CMakeLists.txt ===
project(darktable CXX C)
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)

option(USE_GCONF_BACKEND "Detect and use gconf backend if available." ON)
option(USE_CAMERA_SUPPORT "Detect and use camera support if available." ON)
option(USE_OPENMP "Use openmp threading support." ON)
option(USE_OPENCL "Use OpenCL support." ON)
option(USE_DARKTABLE_PROFILING OFF)
option(DONT_USE_RAWSPEED "Dont compile rawspeed backend." OFF)
option(DONT_INSTALL_GCONF_SCHEMAS "Dont install gconf schemas, usefull for package creation." OFF)
option(BUILD_USERMANUAL "Build all the versions of the usermanual." OFF)
option(INSTALL_IOP_EXPERIMENTAL "Also install unstable, unfinished, broken, and likely-to-change-soon plugins." OFF)
option(INSTALL_IOP_LEGACY "Also install old plugins we want to get rid of." OFF)
option(BINARY_PACKAGE_BUILD "Sets march optimization to generic" OFF)
option(APRIL_FOOLS "Add the \"file manager\" (a shell) to lighttable mode" OFF)

# Generate multi arch triplet
EXECUTE_PROCESS(COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH OUTPUT_VARIABLE CMAKE_ARCH_TRIPLET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(CMAKE_ARCH_TRIPLET)
	message("-- mutliarch triplet detected: " ${CMAKE_ARCH_TRIPLET})
	LIST(INSERT CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES 0 /lib/${CMAKE_ARCH_TRIPLET}
		/usr/lib/${CMAKE_ARCH_TRIPLET})
endif()

#
# Set platform defaults...
#
if(APPLE)
	message("-- Mac OSX build detected, setting default features")
	set(USE_GCONF_BACKEND OFF) 
	set(USE_CAMERA_SUPPORT OFF)
	
	# setup mac ports path...
	set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /opt/local/lib)
	set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} /opt/local/include)
	
	set(LIBS ${LIBS} -Wl,-framework -Wl,Carbon)
endif(APPLE)

if(WIN32)
 message("-- Win32 build detected, setting default features")
  set(USE_GCONF_BACKEND OFF) 
  set(USE_CAMERA_SUPPORT OFF)
endif(WIN32)

# Check if this is source package build
if(NOT IS_DIRECTORY ${CMAKE_SOURCE_DIR}/.git)
	set(SOURCE_PACKAGE 1)
endif()

#
# Set package version
#
if(NOT SOURCE_PACKAGE)
	message("-- Determining version")
	exec_program(git ${CMAKE_CURRENT_SOURCE_DIR} ARGS describe --tags HEAD | "sed 's,^release-,,;s,-,+,;s,-,~,;'" OUTPUT_VARIABLE PROJECT_VERSION)
	configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/version.cmake.cmake" "${CMAKE_CURRENT_BINARY_DIR}/version.cmake" @ONLY)
else(NOT SOURCE_PACKAGE)
	include(cmake/version.cmake)
endif()

#
# Initial cmake/debian/postinst and prerm script for debian package
#
make_directory(${CMAKE_CURRENT_SOURCE_DIR}/packaging/debian)


#
# Avoid source tree pollution
#
If(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=RelWithDebInfo. Use ccmake to set a proper value.")
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(WIN32)
	set(SHARE_INSTALL "." CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
else(WIN32)
	if(NOT SHARE_INSTALL)
		set(SHARE_INSTALL "share/darktable" CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
	endif(NOT SHARE_INSTALL)
endif(WIN32)

mark_as_advanced(SHARE_INSTALL)

if(WIN32)
	set(LIB_INSTALL "." CACHE STRING "Library file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
else(WIN32)
	if(NOT LIB_INSTALL)
		set( LIB_INSTALL lib${LIB_SUFFIX} CACHE STRING "Library file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
	endif(NOT LIB_INSTALL)
endif(WIN32)

mark_as_advanced(LIB_INSTALL)

#need to put here do setting LOCALE_DIR variable
find_package(Gettext)
if(Gettext_FOUND)
	if(NOT LOCALE_DIR)
		if(WIN32)
			SET(LOCALE_DIR "bin/locale")
		elseif(APPLE)
			SET(LOCALE_DIR "share/locale")
		else()#other os
			SET(LOCALE_DIR "${CMAKE_INSTALL_PREFIX}/share/locale")
		endif(WIN32)
	endif(NOT LOCALE_DIR)
	
	if(NOT LOCALE_DIR)
		message(QUIET "Set LOCALE_DIR to path to get Gettext working")
	else()
		find_package(Msgfmt)
		if(Msgfmt_FOUND)
			message(STATUS "Found msgfmt to convert language file. Translation enabled")
			add_subdirectory(po)
		else()
			message(STATUS "Cannot find msgfmt to convert language file. Translation won't be enabled")
		endif()
	endif(NOT LOCALE_DIR)
endif(Gettext_FOUND)

# needed to generate file "create_preferences.sh" accordingly
if(USE_OPENCL)
	SET(HAVE_OPENCL 1)
else()
	SET(HAVE_OPENCL 0)
endif(USE_OPENCL)

#
# Test SSE level
#
# if(NOT USE_SSE_FLAG)
# 	set(SSE_C_TESTS "sse4" "sse3" "sse2" "sse")
# 	message("-- Checking SSE instructions support by current CPU")
# 	foreach(sse_test ${SSE_C_TESTS})
# 		if(NOT SSE_FOUND)
# 			if(WIN32)
# 				set(SSE_CHECK_COMMAND "FAILURE")
# 			elseif(APPLE)
# 				set(SSE_CHECK_COMMAND sysctl -a | grep ${sse_test})
# 			else()#other os
# 				set(SSE_CHECK_COMMAND grep ${sse_test} /proc/cpuinfo)
# 			endif(WIN32)
# 			execute_process(COMMAND ${SSE_CHECK_COMMAND} RESULT_VARIABLE ret_var OUTPUT_VARIABLE out_var)
# 			
# 			if(ret_var EQUAL 0) # grep returns 0 on success
# 				set(SSE_FOUND TRUE)
# 				message("--  ${sse_test} detected and working.")
# 				set(USE_SSE_SET ${sse_test})
# 			endif(ret_var EQUAL 0)
# 			
# 		endif(NOT SSE_FOUND)
# 	endforeach(sse_test)
# endif(NOT USE_SSE_FLAG)
# 
# # set the SSE
# if(USE_SSE_SET)
# 	set(CMAKE_C_FLAGS ${CMAKE_C_FLAGS} "-m${USE_SSE_SET}")
# endif(USE_SSE_SET)

# Path to install gconf schemas into.
if(NOT DT_GCONF_SCHEMA_DIR)
  # a home install would use: "xml:readwrite:${HOME}/.gconf"
  # default gconftool-2 path (gconftool-2 --get-default-source), mostly "xml:merged:/etc/gconf/gconf.xml.defaults"
  execute_process (COMMAND gconftool-2 --get-default-source OUTPUT_VARIABLE DT_GCONF_SCHEMA_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
endif(NOT DT_GCONF_SCHEMA_DIR)

# setup some theme specific variables
set(THEME hicolor)
set(THEME_DIRECTORY ${CMAKE_INSTALL_PREFIX}/share/icons/${THEME})

# lets continue into build directories
add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(doc)

include(cmake/darktable-packaging.cmake)

# create_preferences.sh depending on opencl
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/tools/create_preferences.sh.in"
    "${CMAKE_CURRENT_BINARY_DIR}/create_preferences.sh"
    IMMEDIATE @ONLY)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== data/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

add_subdirectory(pixmaps)

add_subdirectory(kernels)

#
# install darktable faster wrapper
#
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/darktable-faster DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

#
# Generate and instal gtkrc
#
set(GTKRC_FONT_SIZE 8)
if(APPLE)
  # 8 is very tiny on mac
  set(GTKRC_FONT_SIZE 11)
endif(APPLE)
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/darktable.gtkrc.in ${CMAKE_CURRENT_BINARY_DIR}/darktable.gtkrc )


#
# Add files that should go into shared
#
set(SHARE_FILES ${CMAKE_CURRENT_BINARY_DIR}/darktable.gtkrc)
install(FILES ${SHARE_FILES} DESTINATION ${SHARE_INSTALL})

#
# web gallery export support files:
#
set(WEB_FILES style/style.css style/favicon.ico)
install(FILES ${WEB_FILES} DESTINATION ${SHARE_INSTALL}/style/)

#
# Install other system shares
#
install(FILES darktable.desktop DESTINATION ./share/applications)

#
# Install watermarks
#
FILE(GLOB WATERMARKS "watermarks/*.svg")
install(FILES ${WATERMARKS} DESTINATION ${SHARE_INSTALL}/watermarks)

#
# Install gconf schema.
#

if(USE_GCONF_BACKEND)
  if(NOT DONT_INSTALL_GCONF_SCHEMAS)
    install (CODE "set(ENV{GCONF_CONFIG_SOURCE} ${DT_GCONF_SCHEMA_DIR})
        execute_process(WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} OUTPUT_QUIET COMMAND gconftool-2 --makefile-install-rule darktable.schemas)")
    install (CODE "message(\"-- Installing: gconf schemas to '${DT_GCONF_SCHEMA_DIR}'\")")
    install (CODE "execute_process(WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} OUTPUT_QUIET COMMAND killall -HUP gconfd-2)")
    install (CODE "message(\"-- Installing: restarting gconfd-2\")")
  else()
    install(FILES darktable.schemas DESTINATION /etc/gconf/schemas)
  endif(NOT DONT_INSTALL_GCONF_SCHEMAS)
else()
 # Setup some custom commands to generate a darktablerc template
 # out of the darktable.schemas file.
 add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
    COMMAND 
        grep '<key>' ${CMAKE_CURRENT_SOURCE_DIR}/darktable.schemas | 
        sed -e 's/<key>//g' -e 's/<\\/key>//g' -e 's/\\/schemas\\/apps\\/darktable\\///g' | 
        nl -s: | 
        sed -e 's/^[ \\t]*//\;s/[ \\t]*$$//' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
  )
 
  add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
    COMMAND 
        grep '<default>' ${CMAKE_CURRENT_SOURCE_DIR}/darktable.schemas | 
        sed -e 's/<default>//g' -e 's/<\\/default>//g' | 
        nl -s: | 
        sed -e 's/^[ \\t]*//\;s/[ \\t]*$$//' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
        
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
  )
 
  add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
    COMMAND 
      join -1 1 -2 1 -o 1.2 2.2 ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values | 
      sed -e 's/ /=/g' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
      
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
  )
 
  add_custom_target(darktablerc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc)
 
  # first of all install darktablerc file into share as template
  # postinst script should copy this into users homedirectory 
  # $HOME/.config/darktable/darktable.rc
  install(FILES darktablerc DESTINATION ${SHARE_INSTALL}/)
  
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -65,7 +65,7 @@
 
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
-include_directories(${CMAKE_CURRENT_SOURCE_DIR}/LibRaw)
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external/LibRaw)
 
 # initial compiler flags
 add_definitions("-DHAVE_CONFIG_H")
@@ -257,6 +257,15 @@
 SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h PROPERTIES GENERATED 1)
 
 #
+# Generation of the accels translation strings file
+#
+add_custom_command(
+    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/accelstrings_gen.h
+    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/create_accel_strings.sh ${CMAKE_CURRENT_SOURCE_DIR} > ${CMAKE_CURRENT_BINARY_DIR}/accelstrings_gen.h
+)
+SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/accelstrings_gen.h PROPERTIES GENERATED 1)
+
+#
 # Generate mapping of key strings to internal metadata id
 #
 add_custom_command(
@@ -272,7 +281,7 @@
 #
 # build libdarktable
 #
-add_library(lib_darktable STATIC SHARED ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c ${SOURCES})
+add_library(lib_darktable STATIC SHARED ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c ${CMAKE_CURRENT_BINARY_DIR}/accelstrings_gen.h ${SOURCES})
 if(APPLE)
   set_target_properties(lib_darktable PROPERTIES INSTALL_NAME_DIR "@executable_path/../lib/darktable")
 endif(APPLE)
@@ -288,7 +297,7 @@
 #
 add_dependencies(lib_darktable libraw_r)
 add_library(libraw_static STATIC IMPORTED)
-set_target_properties(libraw_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/LibRaw/liblibraw_r.a)
+set_target_properties(libraw_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/external/LibRaw/liblibraw_r.a)
 target_link_libraries(lib_darktable ${LIBS} libraw_static)
 
 # same for librawspeed (can switch it off with -DDONT_USE_RAWSPEED, for macs):
@@ -296,17 +305,17 @@
   add_definitions("-DHAVE_RAWSPEED")
   add_dependencies(lib_darktable rawspeed)
   add_library(rawspeed_static STATIC IMPORTED)
-  set_target_properties(rawspeed_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/rawspeed/librawspeed.a)
+  set_target_properties(rawspeed_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/external/rawspeed/librawspeed.a)
   target_link_libraries(lib_darktable ${LIBS} rawspeed_static)
   # compile rawspeed
-  add_subdirectory(rawspeed)
+  add_subdirectory(external/rawspeed)
 endif(NOT DONT_USE_RAWSPEED)
 
 install(TARGETS lib_darktable DESTINATION ${LIB_INSTALL}/darktable)
 list(APPEND LIBS lib_darktable)
 
 # Compile libraw modules
-add_subdirectory(LibRaw)
+add_subdirectory(external/LibRaw)
 
 # Compile views modules
 add_subdirectory(views)

=== src/dtview/CMakeLists.txt ===

include_directories(${SDL_INCLUDE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/..)
add_executable(darktable-viewer main.c)

set_target_properties(darktable-viewer PROPERTIES CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
set_target_properties(darktable-viewer PROPERTIES CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
set_target_properties(darktable-viewer PROPERTIES INSTALL_RPATH $ORIGIN/../${LIB_INSTALL}/darktable)
set_target_properties(darktable-viewer PROPERTIES LINKER_LANGUAGE C)
target_link_libraries(darktable-viewer lib_darktable ${SDL_LIBRARY} ${OPENGL_LIBRARIES})
install(TARGETS darktable-viewer DESTINATION bin)

=== src/iop/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories("${CMAKE_CURRENT_BINARY_DIR}/../" "${CMAKE_CURRENT_SOURCE_DIR}")

set(MODULES tonecurve gamma temperature colorcorrection exposure 
	colorin colorout clipping sharpen monochrome basecurve colorzones
	basecurve highlights velvia vignette splittoning grain bilateral
	profile_gamma colorcontrast
	channelmixer graduatednd relight zonesystem demosaic atrous tonemap 
	cacorrect overexposed bloom soften clahe equalizer highpass hotpixels lowlight spots rawdenoise borders nlmeans)



# new/unfinshed/unstable plugins:
set(EXPERIMENTAL_MODULES anlfyeni colorcontrast colortransfer)

add_library(soften MODULE "soften.c")
add_library(bloom MODULE "bloom.c")
add_library(highpass MODULE "highpass.c")
add_library(tonemap MODULE "tonemap.cc")
add_library(tonecurve MODULE "tonecurve.c")
add_library(gamma MODULE "gamma.c")
add_library(temperature MODULE "temperature.c")
add_library(colorcorrection MODULE "colorcorrection.c")
add_library(exposure MODULE "exposure.c")
add_library(equalizer MODULE "equalizer.c")
add_library(colorin MODULE "colorin.c")
add_library(colorout MODULE "colorout.c")
add_library(clipping MODULE "clipping.c")
add_library(sharpen MODULE "sharpen.c")
add_library(monochrome MODULE "monochrome.c")
add_library(basecurve MODULE "basecurve.c")
add_library(colorzones MODULE "colorzones.c")
add_library(highlights MODULE "highlights.c")
add_library(velvia MODULE "velvia.c")
add_library(vignette MODULE "vignette.c")
add_library(splittoning MODULE "splittoning.c")
add_library(grain MODULE "grain.c")
add_library(clahe MODULE "clahe.c")
add_library(anlfyeni MODULE "anlfyeni.c")
add_library(bilateral MODULE "bilateral.cc")
add_library(profile_gamma MODULE "profile_gamma.c")
add_library(colortransfer MODULE "colortransfer.c")
add_library(channelmixer MODULE "channelmixer.c")
add_library(graduatednd MODULE "graduatednd.c")
add_library(relight MODULE "relight.c")
add_library(zonesystem MODULE "zonesystem.c")
add_library(demosaic MODULE "demosaic.c")
add_library(atrous MODULE "atrous.c")
add_library(cacorrect MODULE "cacorrect.c")
add_library(overexposed MODULE "overexposed.c")
add_library(hotpixels MODULE "hotpixels.c")
add_library(lowlight MODULE "lowlight.c")
add_library(spots MODULE "spots.c")
add_library(rawdenoise MODULE "rawdenoise.c")
add_library(borders MODULE "borders.c")
add_library(nlmeans MODULE "nlmeans.c")
add_library(colorcontrast MODULE "colorcontrast.c")

if(RSVG2_FOUND)
	add_library(watermark MODULE "watermark.c")
	set(MODULES ${MODULES} watermark)
endif(RSVG2_FOUND)

if(LENSFUN_FOUND)
	add_library(lens MODULE "lens.c")
	set(MODULES ${MODULES} lens)
endif(LENSFUN_FOUND)

# Add libs references
foreach(module ${MODULES})
        target_link_libraries(${module} ${LIBS})
endforeach(module)
foreach(module ${EXPERIMENTAL_MODULES})
        target_link_libraries(${module} ${LIBS})
endforeach(module)

foreach(module ${MODULES})
	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/plugins)
endforeach(module)

if(INSTALL_IOP_EXPERIMENTAL)
  message("-- Installing experimental iop plugins")
  foreach(module ${EXPERIMENTAL_MODULES})
    	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/plugins)
  endforeach(module)
endif(INSTALL_IOP_EXPERIMENTAL)

=== src/external/rawspeed/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

install(FILES data/cameras.xml data/showcameras.xsl DESTINATION ${SHARE_INSTALL}/rawspeed)

set(RAWSPEED_SOURCES
  "RawSpeed/ArwDecoder.cpp"
  "RawSpeed/BitPumpJPEG.cpp"
  "RawSpeed/BitPumpMSB32.cpp"
  "RawSpeed/BitPumpMSB.cpp"
  "RawSpeed/BitPumpPlain.cpp"
  "RawSpeed/BlackArea.cpp"
  "RawSpeed/ByteStream.cpp"
  "RawSpeed/ByteStreamSwap.cpp"
  "RawSpeed/Camera.cpp"
  "RawSpeed/CameraMetaData.cpp"
  "RawSpeed/CameraMetadataException.cpp"
  "RawSpeed/ColorFilterArray.cpp"
  "RawSpeed/Common.cpp"
  "RawSpeed/Cr2Decoder.cpp"
  "RawSpeed/DngDecoder.cpp"
  "RawSpeed/DngDecoderSlices.cpp"
  "RawSpeed/FileIOException.cpp"
  "RawSpeed/FileMap.cpp"
  "RawSpeed/FileReader.cpp"
  "RawSpeed/IOException.cpp"
  "RawSpeed/LJpegDecompressor.cpp"
  "RawSpeed/LJpegPlain.cpp"
  "RawSpeed/NefDecoder.cpp"
  "RawSpeed/NikonDecompressor.cpp"
  "RawSpeed/OrfDecoder.cpp"
  "RawSpeed/PefDecoder.cpp"
  "RawSpeed/PentaxDecompressor.cpp"
  "RawSpeed/RawDecoder.cpp"
  "RawSpeed/RawDecoderException.cpp"
  "RawSpeed/RawImage.cpp"
  "RawSpeed/Rw2Decoder.cpp"
  "RawSpeed/StdAfx.cpp"
  "RawSpeed/TiffEntryBE.cpp"
  "RawSpeed/TiffEntry.cpp"
  "RawSpeed/TiffIFDBE.cpp"
  "RawSpeed/TiffIFD.cpp"
  "RawSpeed/TiffParser.cpp"
  "RawSpeed/TiffParserException.cpp"
  "RawSpeed/TiffParserHeaderless.cpp"
  "RawSpeed/TiffParserOlympus.cpp"
  "RawSpeed/RawImageDataU16.cpp"
  "RawSpeed/RawImageDataFloat.cpp"
  "RawSpeed/SrwDecoder.cpp"
    )

#
# build librawspeed
#
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

add_library(rawspeed STATIC ${RAWSPEED_SOURCES})
target_link_libraries(rawspeed)

=== debian/changelog ===
darktable (0.9.1-2) unstable; urgency=low

  * patch upstream copy of FindGTK2.cmake to work with multi-arch
    (fixes KFreeBSD FTBFS).

 -- David Bremner <bremner@debian.org>  Tue, 16 Aug 2011 23:07:57 -0300

darktable (0.9.1-1) unstable; urgency=low

  * New upstream release

 -- David Bremner <bremner@debian.org>  Tue, 02 Aug 2011 21:32:31 +0200

## darktable 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,11 @@
 
 option(USE_GCONF_BACKEND "Detect and use gconf backend if available." ON)
 option(USE_CAMERA_SUPPORT "Detect and use camera support if available." ON)
+option(USE_NLS "Build Native Language Support (using gettext)" ON)
+option(USE_FLICKR "Enable Flickr support" ON)
+option(USE_KWALLET "Build kwallet password storage backend" ON)
+option(USE_GNOME_KEYRING "Build gnome-keyring password storage backend" ON)
+option(BUILD_SLIDESHOW "Build the opengl slideshow viewer" ON)
 option(USE_OPENMP "Use openmp threading support." ON)
 option(USE_OPENCL "Use OpenCL support." ON)
 option(USE_DARKTABLE_PROFILING OFF)
@@ -101,6 +106,7 @@
 mark_as_advanced(LIB_INSTALL)
 
 #need to put here do setting LOCALE_DIR variable
+if(USE_NLS)
 find_package(Gettext)
 if(Gettext_FOUND)
 	if(NOT LOCALE_DIR)
@@ -125,6 +131,7 @@
 		endif()
 	endif(NOT LOCALE_DIR)
 endif(Gettext_FOUND)
+endif(USE_NLS)
 
 # needed to generate file "create_preferences.sh" accordingly
 if(USE_OPENCL)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,7 @@
   "develop/imageop.c"
   "develop/pixelpipe.c"
   "develop/blend.c"
+  "develop/tiling.c"
   "dtgtk/*.c" 
   "gui/background_jobs.c"  
   "gui/contrast.c"  
@@ -61,10 +62,21 @@
   )
 FILE(GLOB HEADER_FILES "*.h" "common/*.h" "external/CL/*.h" "control/*.h" "iop/*.h" "libs/*.h", "views/*.h")
 
+# Files that could conceivable contain accelerator definitions
+FILE(GLOB ACCEL_SOURCES
+  "create_accel_strings.sh"
+  "develop/imageop.c"
+  "gui/gtk.c"
+  "iop/*.c"
+  "libs/*.c"
+  "views/*.c"
+)
+
 set(SOURCES ${SOURCE_FILES} ${HEADER_FILES})
 
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external/LibRaw)
 
 # initial compiler flags
@@ -124,51 +136,61 @@
   add_definitions(${${lib}_DEFINITIONS})
 endforeach(lib)
 
-find_package(Gettext)
-if(Gettext_FOUND)
-  include_directories(${Gettext_INCLUDE_DIRS})
-  list(APPEND LIBS ${Gettext_LIBRARIES})
-  add_definitions("-DUSE_GETTEXT")
-  message(STATUS "Internationalization: Enabled")
-else()
-  message(STATUS "Internationalization: Disabled (libintl not found)")
-endif()
-
-find_package(FLICKCURL)
-if(FLICKCURL_FOUND)
-  include_directories(${FLICKCURL_INCLUDE_DIRS})
-  list(APPEND LIBS ${FLICKCURL_LIBRARIES})
-  add_definitions(${FLICKCURL_DEFINITIONS})
-endif(FLICKCURL_FOUND)
+if(USE_NLS)
+  find_package(Gettext)
+  if(Gettext_FOUND)
+    include_directories(${Gettext_INCLUDE_DIRS})
+    list(APPEND LIBS ${Gettext_LIBRARIES})
+    add_definitions("-DUSE_GETTEXT")
+    message(STATUS "Internationalization: Enabled")
+  else()
+    message(STATUS "Internationalization: Disabled (libintl not found)")
+  endif()
+endif(USE_NLS)
+
+if(USE_FLICKR)
+  find_package(FLICKCURL)
+  if(FLICKCURL_FOUND)
+    include_directories(${FLICKCURL_INCLUDE_DIRS})
+    list(APPEND LIBS ${FLICKCURL_LIBRARIES})
+    add_definitions(${FLICKCURL_DEFINITIONS})
+  endif(FLICKCURL_FOUND)
+endif(USE_FLICKR)
 
 #
 # Detect compile of optional pwstorage backends
 #
+if(USE_KWALLET) 
 find_package(DBUSGLIB)
-if(DBUSGLIB_FOUND)
-  list(APPEND SOURCES "common/pwstorage/backend_kwallet.c")
-  include_directories(${DBUSGLIB_INCLUDE_DIRS})
-  list(APPEND LIBS ${DBUSGLIB_LIBRARIES})
-  add_definitions("-DHAVE_KWALLET")
-endif(DBUSGLIB_FOUND)
-
-find_package(GnomeKeyring)
-if(GNOMEKEYRING_FOUND)
-  set(SOURCES ${SOURCES} "common/pwstorage/backend_gkeyring.c")
-  include_directories(${GnomeKeyring_INCLUDE_DIRS})
-  list(APPEND LIBS ${GnomeKeyring_LIBRARIES})
-  add_definitions("-DHAVE_GKEYRING")
-endif(GNOMEKEYRING_FOUND)
+  if(DBUSGLIB_FOUND)
+    list(APPEND SOURCES "common/pwstorage/backend_kwallet.c")
+    include_directories(${DBUSGLIB_INCLUDE_DIRS})
+    list(APPEND LIBS ${DBUSGLIB_LIBRARIES})
+    add_definitions("-DHAVE_KWALLET")
+  endif(DBUSGLIB_FOUND)
+endif(USE_KWALLET)
+
+if(USE_GNOME_KEYRING)
+  find_package(GnomeKeyring)
+  if(GNOMEKEYRING_FOUND)
+    set(SOURCES ${SOURCES} "common/pwstorage/backend_gkeyring.c")
+    include_directories(${GnomeKeyring_INCLUDE_DIRS})
+    list(APPEND LIBS ${GnomeKeyring_LIBRARIES})
+    add_definitions("-DHAVE_GKEYRING")
+  endif(GNOMEKEYRING_FOUND)
+endif(USE_GNOME_KEYRING)
 
 # have a small test program, to be run as root on some systems to enable the driver to run cl stuff
 add_subdirectory(cltest)
 
 # build opengl slideshow viewer?
-find_package(SDL)
-find_package(OpenGL)
-if(SDL_FOUND AND OPENGL_FOUND)
-  add_subdirectory(dtview)
-endif(SDL_FOUND AND OPENGL_FOUND)
+if(BUILD_SLIDESHOW) 
+  find_package(SDL)
+  find_package(OpenGL)
+  if(SDL_FOUND AND OPENGL_FOUND)
+    add_subdirectory(dtview)
+  endif(SDL_FOUND AND OPENGL_FOUND)
+endif(BUILD_SLIDESHOW)
 
 # needed for the file manager
 if(APRIL_FOOLS)
@@ -199,7 +221,6 @@
 endif(OPENEXR_FOUND)
 
 if(USE_OPENCL)
-  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external)
   add_definitions("-DHAVE_OPENCL")
 endif(USE_OPENCL)
 
@@ -262,6 +283,7 @@
 add_custom_command(
     OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/accelstrings_gen.h
     COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/create_accel_strings.sh ${CMAKE_CURRENT_SOURCE_DIR} > ${CMAKE_CURRENT_BINARY_DIR}/accelstrings_gen.h
+    DEPENDS ${ACCEL_SOURCES}
 )
 SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_BINARY_DIR}/accelstrings_gen.h PROPERTIES GENERATED 1)

=== src/views/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories("${CMAKE_CURRENT_BINARY_DIR}/../" "${CMAKE_CURRENT_SOURCE_DIR}")
set(MODULES filmstrip darkroom lighttable)

add_library(filmstrip MODULE "filmstrip.c")
add_library(darkroom MODULE "darkroom.c")
add_library(lighttable MODULE "lighttable.c")

if(GPHOTO2_FOUND)
	add_library(views_capture MODULE "capture.c")
	set_target_properties(views_capture PROPERTIES OUTPUT_NAME capture)
	set(MODULES ${MODULES} views_capture)
endif(GPHOTO2_FOUND)

foreach(module ${MODULES})
	target_link_libraries(${module} ${LIBS})
endforeach(module)

foreach(module ${MODULES})
	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/views)
endforeach(module)

=== debian/changelog ===
darktable (0.9.2-1) unstable; urgency=low

  * New upstream version
  * (equivalents of) all patches now upstream

 -- David Bremner <bremner@debian.org>  Sat, 27 Aug 2011 08:41:10 -0300

=== debian/control ===
Source: darktable
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Bernd Zeimetz <bzed@debian.org>, David Bremner <bremner@debian.org>
Build-Depends: debhelper (>= 7.0.50~), cmake,
 liblcms2-dev, libgtk2.0-dev, libglib2.0-dev, libcairo2-dev, 
 libjpeg-dev, libpng-dev, libgconf2-dev, liblensfun-dev,
 libtiff-dev, libexiv2-dev, intltool, libglade2-dev,
 libsqlite3-dev, libopenexr-dev, libgphoto2-2-dev,
 libcurl4-gnutls-dev|libcurl-dev, libdbus-glib-1-dev, libgnome-keyring-dev,
 librsvg2-dev
Standards-Version: 3.9.2
Homepage: http://darktable.sourceforge.net/
Vcs-Git: git://git.debian.org/pkg-phototools/darktable.git
Vcs-Browser: http://git.debian.org/?p=pkg-phototools/darktable.git;a=summary

Package: darktable
Architecture: any-i386 any-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, gtk2-engines
Replaces: darktable-plugins-legacy (<< 0.9), darktable-plugins-experimental (<< 0.9)
Breaks: darktable-plugins-legacy (<< 0.9), darktable-plugins-experimental (<< 0.9)
Description: virtual lighttable and darkroom for photographers
 Darktable manages your digital negatives in a database and lets you view
 them  through a zoomable lighttable. it also enables you to develop raw
 images and enhance them.
 .
 It tries to fill the gap between the many excellent existing free
 raw converters and image management tools (such as ufraw or f-spot).
 The user interface is built around efficient caching of image metadata and
 mipmaps, all stored in a database. the user will always be able to interact,
 even if the full resolution image is not yet loaded.
 .
 All editing is fully non-destructive and only operates on cached image
 buffers for display. the full image is only converted during export. The
 frontend is written in gtk+/cairo, the database uses sqlite3, raw image
 loading is done using libraw, high-dynamic range, and standard image formats
 such as jpeg are also supported. The core operates completely on floating
 point values, so darktable can not only be used for photography but also for
 scientifically acquired images or output of renderers (high dynamic range).

Package: darktable-dbg
Architecture: any-i386 any-amd64
Section: debug
Priority: extra
Depends: ${misc:Depends}, darktable (= ${binary:Version})
Description: virtual lighttable and darkroom for photographers
 Darktable manages your digital negatives in a database and lets you view
 them  through a zoomable lighttable. it also enables you to develop raw
 images and enhance them.
 .
 This package contains the debugging symbols

Package: darktable-plugins-experimental
Architecture: any-i386 any-amd64
Replaces: darktable (<<0.9)
Breaks: darktable (<<0.9)
Depends: ${shlibs:Depends}, ${misc:Depends}, darktable (= ${binary:Version})
Description: virtual lighttable and darkroom for photographers (experimental plugins)
 Darktable manages your digital negatives in a database and lets you view
 them  through a zoomable lighttable. it also enables you to develop raw
 images and enhance them.
 .
 This package contains the experimental plugins which may be unstable and/or
 may cause weird behavior.
